

#include <stdlib.h>
#include "matrix_lib.h"

/** allocates a 3d cube with dim. m*n*o */
void allocate_cube(double ****cube, int m, int n, int o) {
  int i, j;
  double ***c;
  c = malloc(m * sizeof(double **));
  c[0] = malloc(m * n * sizeof(double *));

  for (i = 0; i < m; i++)
    c[i] = c[0] + n*i;

  c[0][0] = malloc(m * n * o * sizeof(double));

  for (i = 0; i < m; i++)
    for (j = 0; j < n; j++)
      c[i][j] = c[0][0] + o*j + o*n*i;
  *cube = c;
}

/** allocates a 2d matrix of dim. m*n */
void allocate_matrix(double ***matrix, int m, int n) {
  double *matrix_k, **matrix_l;
  int i;

  matrix_k = calloc(m*n, sizeof(double));
  matrix_l = malloc(m*sizeof(double*));
  for(i = 0; i < m; i++)
    matrix_l[i] = &(matrix_k[i*n]);

  *matrix = matrix_l;
}

/** allocates 1d vector of dim n */
void allocate_vector(double **vector, int n) {
  double *v = malloc(n*sizeof(double));
  *vector = v;
}

void deallocate_cube(double ***cube) {
  free(cube[0][0]);
  free(cube[0]);
  free(cube);
}

void deallocate_matrix(double **matrix) {
  free(matrix[0]);
  free(matrix);
}

void deallocate_vector(double *vector) {
  free(vector);
}
